<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\master_worker;


use app\common\model\master_worker\BankAccount;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * BankAccount逻辑
 * Class BankAccountLogic
 * @package app\adminapi\logic\master_worker
 */
class BankAccountLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/10/08 09:41
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            BankAccount::create([
                'account_holder' => $params['account_holder'],
                'bank_name' => $params['bank_name'],
                'province' => $params['province'],
                'city' => $params['city'],
                'opening_branch' => $params['opening_branch'],
                'account' => $params['account'],
                'bank_image' => $params['bank_image'],
                'mobile' => $params['mobile'],
                'worker_id' => $params['worker_id'],
                'audit_state' => $params['audit_state'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/10/08 09:41
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            BankAccount::where('id', $params['id'])->update([
                'account_holder' => $params['account_holder'],
                'bank_name' => $params['bank_name'],
                'province' => $params['province'],
                'city' => $params['city'],
                'opening_branch' => $params['opening_branch'],
                'account' => $params['account'],
                'bank_image' => $params['bank_image'],
                'mobile' => $params['mobile'],
                'worker_id' => $params['worker_id'],
                'audit_state' => $params['audit_state'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/10/08 09:41
     */
    public static function delete(array $params): bool
    {
        return BankAccount::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/10/08 09:41
     */
    public static function detail($params): array
    {
        return BankAccount::findOrEmpty($params['id'])->toArray();
    }

    public static function getWorkerIds($params): array
    {
        return BankAccount::where('id',is_array($params['id'])?'in':'=',$params['id'])->column('worker_id');
    }
}